#include "StdAfx.h"
#include "resource.h"
#include "TestWnd.h"
#include "listbox.h"
#include "palettenWnd.h"
#include "UidDlg.h"
#include "zielView.h"
#define m_btnlist  m_Btns 
#define m_btncancel m_Btns[6]
static const BUTTON_ITEMEX Button_Info[] = 
{
	{ 30, 30, 331,72,100,	IDBI_BUTTON_89X43,IDBI_BUTTON_89X43_DN, 14, 0, 0,0,0,32,FW_NORMAL/*,	FALSE*/},
	{ 230,30,331,72, 101,	IDBI_BUTTON_89X43,IDBI_BUTTON_89X43_DN, 14, 0, 0,0,0,32,FW_NORMAL/*,FALSE*/},
	{ 30, 110,331,72,102,	IDBI_BUTTON_89X43,IDBI_BUTTON_89X43_DN, 14, 0, 0,0,0,32,FW_NORMAL/*,FALSE*/},
	{ 230,110,331,72,103,	IDBI_BUTTON_89X43,IDBI_BUTTON_89X43_DN, 14, 0, 0,0,0,32,FW_NORMAL/*,FALSE*/},
//	{ 30, 190,331,72,104,	IDBI_BUTTON_89X43,IDBI_BUTTON_89X43_DN, 14, 0, 0,0,0,32,FW_NORMAL/*,FALSE*/},
//	{ 230,190,331,72,105,	IDBI_BUTTON_89X43,IDBI_BUTTON_89X43_DN, 14, 0, 0,0,0,32,FW_NORMAL/*,FALSE*/},

};

BUTTON_ITEM Button_Cancel[2] ={ { 600-80, 300-80, Btn_CancelWidth,Btn_CancelHeight,IDCANCEL,	IDBI_CANCEL,IDBI_CANCEL_DN},
{0,0,0,0,0,0,0}};

TCHAR * testName[]={
	//L"newstatus", L"Palleten",L"PosMeldung",L"GEHEZU",L"ZielView",L"durTimer"
	L"Lat", L"Lon",L"Satelite",L"Speed"//,L"engine" 
};

LRESULT CTestWnd::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CString str;
	//VButtonWnd::OnInitDialog( uMsg,  wParam,  lParam,  bHandled);
	for(DWORD count=0 ; count<sizeof(Button_Info)/sizeof(BUTTON_ITEMEX) ; count++)
	{
		str.LoadString(Button_Info[count].uId);
		CREATE_BTN_TRANS(m_btnlist[count], IDBI_BK,testName[count],Button_Info[count]);
	}

	CREATE_BTN_TRANS2(m_btncancel, IDBI_BK,Button_Cancel[0]);
	MoveWindow(0,0,600,300);
	BringWindowToTop();
return 0;
}


extern CSimpleArray<SavedNaviRecord_t> g_listJobSaved;
void durTimerWndTest();
int  doPosMeldung(struct __JobState * pState,TCHAR* szSel,int __initPos,int __bSpec);
void testNewStatusWnd();
int get_info_text(int i, char* szText);
LRESULT CTestWnd::OnCommand (UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{

int i = LOWORD(wParam);
char szText[32];
TCHAR wcsText[32];
	if (1)
	{

		if(0==get_info_text(i, szText))
		{
			mbstowcs(wcsText,szText,strlen(szText)+1);
			if( i==102 ) ;
			else MessageBox(L"Not used in jobapp", testName[i-100],MB_OK);
			MessageBox(wcsText, testName[i-100],MB_OK);
		}else EndDialog(0);
	}else{
		switch (i)
		{
		case IDOK:
		case IDCANCEL:

			EndDialog(0);
			bHandled = 0;
			return 0;
		case 100:
			{
				testNewStatusWnd();
				 
			}
			break;
		case 101:
			{
			CPalletenWnd dlg1(IDB_BK ,IDB_ICON_PALE,L"Test");
			dlg1.DoModal();
			}
			break;
		case 102:
			{
				TCHAR szSel[16];
				doPosMeldung(NULL, szSel,0,0);
			}
			break;
		case 103: //
			{
			int idBMP= IDB_ICON_AUFT2;
			CString str;
			str.LoadString(IDS_GEHEZU_TITLE);
			CUidDlg dlg(m_hWnd,idBMP,(LPCTSTR)str );
			dlg.DoModal();
			}
			break;
		case 104:
			{
				CZielView dlg(L"Test",NULL);
				dlg.DoModal();
			}
			break;
		case 105:
			durTimerWndTest();
			break;
		}
	}
	
	return 0;
}
LRESULT CTestWnd::OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	//PostMessage(WM_CLOSE);
	EndDialog(0);

return 0;
}
LRESULT CTestWnd::OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	//PostQuitMessage(0);

return 0;
}

void createTestWnd()
{
	CTestWnd dlg(NULL);
	dlg.DoModal();
}

