#include "StdAfx.h"
#include "publicctrl.h"
#include "DrawLib.h"
#include "VStartWnd.h"
#include "cpss_dialog.h"
#include "StatusView.h"

static BUTTON_ITEMEX V6Buttons [] = { 
	{24,209,45,43,ID_LSCROLL,-2},{76,208,132,43,ID_MELDUNG,-2},{215,208,132,43,ID_PAUSE,-2},{354,209,45,43,ID_RSCROLL,-2},
	{416,209,44,43,ID_CANCEL,-2},{414,141,44,43,ID_ENTER,-2},{0,0,0,0,0}
};
#define RECT_DISPLAY_HEAD    27,75,400,100
#define RECT_DISPLAY_STATUS  27,105,400,200
//#define RECT_DISPLAY_STATUS2  27,105,37,95
#define RECT_DISPLAY_COUNT   420,24,470,44	
extern CSimpleArray<CString> m_arStatus[3];


LRESULT VStartWnd::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
/*
  MoveWindow(0,0,480,272);
  BOOL bOK = SetForegroundWindow(m_hWnd);
*/	//m_Button = V6Buttons;
	BUTTON_ITEMEX* pItem;
	
	pItem = V6Buttons;
	LRESULT l = VButtonWnd::OnInitDialog(uMsg,  wParam,  lParam, bHandled);

	int n=((struct __JobState*)m_pState)->fFlag&3;
	int nTotal = m_arStatus[n].GetSize();
	m_nCount  = ((struct __JobState*)m_pState)->dwJobState+1;
	if(m_nCount>=nTotal) m_nCount=0;
    int i=0;	
	while(pItem[i].uId)
	{
		m_Btns[i].CreateWndTrans(m_hWnd,IDBI_BK,pItem[i].rt,
					  pItem[i].uId,
					  pItem[i].bmpId,
					  pItem[i].bmpId_dn
					  );
		i++;
	}	
	
    return 0;  
}

void VStartWnd::OnPaintExt(HDC hDC,CRect&rcPaint)
{
 if(m_pState && ((struct __JobState*)m_pState)->fFlag&FLAG_PAUSE)
{
	CCanvas canvas(hDC);

	CMyBitmap m_Bmp;
	
	canvas.BitBlt(m_Bmp.LoadBitmap(IDR_PAUSE_END),SRCCOPY,V6Buttons[2].rt);
#ifndef __PNG_CACHE__
	m_Bmp.DeleteObject();
#endif
}


	DrawDC Draw(hDC);
	CRect rect(RECT_DISPLAY_STATUS);
	Draw.SetDrawBkMode(TRANSPARENT);
	int n=((struct __JobState*)m_pState)->fFlag&3;
	int nTotal = m_arStatus[n].GetSize();
	if(m_nCount>=0 && m_nCount<nTotal)
	{
		CString str = m_arStatus[n][m_nCount];	
		CString strHead;
		int n = str.Find(TCHAR(';'));
		if(n!=-1)   // change  format of status_xx.ini, add a status number.
		{
			str = str.Right(str.GetLength()-n-1);
			n=str.Find(TCHAR(';'));
			
		}
		Draw.SetDrawFontSize(ButtonFontHeight,0,FW_BOLD,__FONT_BOLD__);
		strHead = str.Left(n);
		rect = CRect(RECT_DISPLAY_HEAD);
		Draw.DrawGPSOverIPStringRect((LPTSTR)(LPCTSTR)strHead,&rect,DT_CENTER);

		rect = CRect(RECT_DISPLAY_COUNT);
		strHead.Format(L"%d/%d",m_nCount+1,nTotal);
		Draw.DrawGPSOverIPStringRect((LPTSTR)(LPCTSTR)strHead,&rect,DT_CENTER);
		
		strHead =  str.Right(str.GetLength()-n-1);
		Draw.SetDrawFontSize(FontHeight-2,0,FW_THIN,__FONT_NORMAL__);
		
		rect = CRect(RECT_DISPLAY_STATUS);
		//Draw.DrawStringRect((LPTSTR)(LPCTSTR)strHead,&rect,DT_CENTER|DT_EDITCONTROL | DT_WORDBREAK);
		Draw.DrawGPSOverIPStringRect((LPTSTR)(LPCTSTR)strHead,&rect,DT_CENTER|DT_EDITCONTROL | DT_WORDBREAK);	
	}


}

LRESULT VStartWnd::OnPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
/*
	m_DrawList->PaintObj(CPaintDC(m_hWnd));

	HDC hDC=GetDC();
    

	DrawDC Draw(hDC);
	//Draw.SetDrawBkMode(TRANSPARENT);
	if(m_nPressed!=-1)
	{
		CRect re(m_Button[m_nPressed].rt);
		re.bottom+=re.top;re.right+=re.left;
		HBRUSH hbr=(HBRUSH) ::SelectObject(hDC, GetStockObject(NULL_BRUSH));
		Draw.DrawRoundRect(&re, 2, 0x80FF, 6,6);
		::SelectObject(hDC, hbr);
	}
	ReleaseDC(hDC);
*/	LRESULT l =VButtonWnd::OnPaint(uMsg,  wParam,  lParam, bHandled);

	return 0;

}

LRESULT VStartWnd::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
//	DestroyWindow();
	ShowWindow(SW_HIDE);
   	EndDialog(FALSE);
	return 0;
}

LRESULT VStartWnd::OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
/*	CPoint pt(LOWORD(lParam),HIWORD(lParam));
	
	CRect re;
	int i=0; m_nPressed = -1;
	while(m_Button[i].uId)
	{
		re = m_Button[i].rt;
		re.bottom+=re.top;re.right+=re.left;
	
		if(re.PtInRect(pt))
		{
			m_nPressed = i;
			InvalidateRect(&re,FALSE);
			UpdateWindow();
			break;
		}
		i++;
	}
	return 0;*/
	LRESULT l =VButtonWnd::OnLButtonDown(uMsg,  wParam,  lParam, bHandled);
	return l;	
}
LRESULT VStartWnd::OnLButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
/*	CPoint pt(LOWORD(lParam),HIWORD(lParam));
	UINT cmd = -1;
	CRect re;
	int i=0;
	while(m_Button[i].uId)
	{
		re = m_Button[i].rt;
		re.bottom+=re.top;re.right+=re.left;
	
		if(re.PtInRect(pt))
		{
			re.InflateRect(3,3);
			if(i!=m_nPressed) break;
			m_nPressed = -1;
			cmd = m_Button[i].uId;
			
			InvalidateRect(&re,TRUE);
			UpdateWindow();
			break;
		}
		i++;
	}
	if(cmd==-1 && m_nPressed!=-1)
	{
		re = m_Button[m_nPressed].rt;
		re.bottom+=re.top;re.right+=re.left;
		re.InflateRect(3,3);
		m_nPressed = -1;
		InvalidateRect(&re,TRUE);
		UpdateWindow();
	}
	switch(cmd)
	{
	case ID_LSCROLL: // pause
		if(m_nCount>0)
		{
			m_nCount--;
			CRect rect(RECT_DISPLAY_STATUS);
			InvalidateRect(&rect,TRUE);
			rect = CRect(RECT_DISPLAY_COUNT);
			InvalidateRect(&rect,TRUE);
			UpdateWindow();
		}
		break;
	case ID_RSCROLL: // pause
		if(m_nCount<m_arStatus.GetSize()-1)
		{
			m_nCount++;	
			CRect rect(RECT_DISPLAY_STATUS);
			InvalidateRect(&rect,TRUE);
			rect = CRect(RECT_DISPLAY_COUNT);
			InvalidateRect(&rect,TRUE);
			UpdateWindow();
		}
		break;
	case ID_PAUSE:
		break;
	case ID_MELDUNG:
		{
			CStatusView dlg(L"");
			int ret = dlg.DoModal();
			if(ret==ID_SWITCH)
			{

			}
		}
		break;
	case ID_CANCEL:
		EndDialog(0);
		break;
	case ID_ENTER:
		break;
	}
	return 0;*/
		LRESULT l =VButtonWnd::OnLButtonUp(uMsg,  wParam,  lParam, bHandled);
	return l;
}
 

	LRESULT VStartWnd::OnMelDung(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
	{
		DoMelDung(((struct __JobState*)m_pState),m_hWnd);
			ShowWindow(SW_HIDE);
			EndDialog(1);
			return 1;
	}
	LRESULT VStartWnd::OnPause(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
	{
		if(m_pState && ((struct __JobState*)m_pState)->fFlag&FLAG_PAUSE)
			send_job_status( ((struct __JobState*)m_pState), L"Pause Ende",-1);
		else
			send_job_status( ((struct __JobState*)m_pState), L"Pause",-1);
		ShowWindow(SW_HIDE);
		EndDialog(1);
		return 1;
	}
	LRESULT VStartWnd::OnEnter(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
	{
			CString str;
			int n = ((struct __JobState*)m_pState)->fFlag&3;
			if(m_nCount>=0 && m_nCount<m_arStatus[n].GetSize())
			{
				str = m_arStatus[n][m_nCount];
				//m_pState->dwJobState = m_nCount;
				int wizardstat = 0x5555;
				int stat = m_nCount;
				int n = str.Find(TCHAR(';'));
				
				if(n!=-1)   // change  format of status_xx.ini, add a status number.
				{
					CString strStat = str.Left(n);
					TCHAR *endptr=0;
					wizardstat =  wcstol((LPCTSTR)strStat,&endptr,0);
					str = str.Right( str.GetLength()-n-1);
				}

				//send_job_status( m_pState,(LPTSTR)(LPCTSTR) str,stat,-1);
				send_job_status( ((struct __JobState*)m_pState),(LPTSTR)(LPCTSTR) str,stat,-2,wizardstat);

				/*if( m_nCount==m_arStatus[n].GetSize()-1) // last state
				{
					if(g_bActiveDel) erase_job(m_pState);
				}*/
				EndDialog(1);
			}
			return 1;
	}

	LRESULT VStartWnd::OnScroll(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
	{
		BOOL bUp = FALSE;
		int n = ((struct __JobState*)m_pState)->fFlag&3;
		if(wID==ID_RSCROLL)
		{
			if(m_nCount<m_arStatus[n].GetSize()-1)
			{
				m_nCount++;	bUp = TRUE;
				
			}
		}else if(wID==ID_LSCROLL)
		{
			if(m_nCount>0)
			{
				m_nCount--;bUp = TRUE;
			}
		}
		if(bUp){
			
			/*CRect rect(RECT_DISPLAY_STATUS);
			InvalidateRect(&rect,TRUE);
			rect = CRect(RECT_DISPLAY_COUNT);
			InvalidateRect(&rect,TRUE);
			rect = CRect(RECT_DISPLAY_HEAD);
			InvalidateRect(&rect,TRUE);
			*/
			Invalidate();
			UpdateWindow();
		}
		return 1;
	}
LRESULT VStartWnd::OnChangeSkin(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	m_DrawList->ChangeSkin();
	EnumChildWindows(m_hWnd,EnumCallback ,0);
	return 0;
}