#include "stdafx.h"
#include "resource.h"
#include "publicctrl.h"
#include "cpss_dialog.h"
#include <stdio.h>
#include "palettenWnd.h"

#define EDIT_X 300
#define EDIT_Y 200
#define EDIT_H 48
#define EDIT_W 200

static BUTTON_ITEMEX V6Buttons [] = { 
	{EDIT_X   , EDIT_Y+EDIT_H+10,44,43,IDD_BTN_MINUS,IDBI_MINUS,IDBI_MINUS_DN},
	{EDIT_X+EDIT_W-73,	EDIT_Y+EDIT_H+10,44,43,IDD_BTN_PLUS,IDBI_PLUS,IDBI_PLUS_DN},
	{Btn_CancelX, Btn_CancelY-90,44,43,IDOK,IDBI_SURE,IDBI_SURE_DN},
	{Btn_CancelX, Btn_CancelY,44,43,ID_CANCEL,IDBI_CANCEL,IDBI_CANCEL_DN},{0,0,0,0,0}
};


LRESULT CPalletenWnd::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	//m_Button = V6Buttons;
	LRESULT l = VButtonWnd::OnInitDialog(uMsg,  wParam,  lParam, bHandled);
	int i;
	
    for(i=0;i<sizeof(V6Buttons)/sizeof(V6Buttons[0]);i++)
	{
		CREATE_BTN_TRANS2(m_Btns[i],m_nIDBACK ,V6Buttons[i]);
	}
  return 0;  
}

void CPalletenWnd::OnPaintExt(HDC hDC,CRect&rcPaint) //UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{

int i=0;
CCanvas canvas(hDC);

	DrawDC Draw(hDC);
	Draw.SetDrawBkMode(TRANSPARENT);

	m_hFont = __CreateFont(FontHeight , FontWide, FW_NORMAL); 

	int X_M=16;
	HFONT hOldFont = Draw.SetFont(m_hFont);
	CString str,strFmt;
	RECT rect;
//	int j;
	str.LoadString(IDS_Leergewichtmeldung);//str.Format(L"Leergewichtmeldung");
	rect.top = 35,rect.left=90,rect.right = 750,rect.bottom=rect.top+40;
	Draw.DrawGPSOverIPStringRect((LPTSTR)(LPCTSTR)str,&rect,DT_LEFT);
				
	strFmt.LoadString(IDS_FMT_TOUR_NR);str.Format(strFmt, m_szName);
	rect.top = 90,rect.left=90,rect.right = 750,rect.bottom=rect.top+40;
	Draw.DrawGPSOverIPStringRect((LPTSTR)(LPCTSTR)str,&rect,DT_LEFT);


	str.LoadString(IDS_Palettenanzahl);//str.Format(L"Palettenanzahl");
	rect.top = EDIT_Y-40,rect.left=EDIT_X,rect.right = EDIT_X+EDIT_W,rect.bottom=rect.top+40;
	Draw.DrawGPSOverIPStringRect((LPTSTR)(LPCTSTR)str,&rect,DT_NOCLIP|DT_LEFT);

	rect.left = EDIT_X ;rect.right = EDIT_X+EDIT_W ;rect.top = EDIT_Y, rect.bottom = rect.top+EDIT_H;
	//rect.left+=EDIT_BORDER*2;rect.right-=EDIT_BORDER*2;
	//rect.top+=EDIT_BORDER;rect.bottom-=EDIT_BORDER;
	//Draw.Draw3DRect(&rect,EDIT_BORDER,EDIT_BORDER);
	//rect.top+=EDIT_BORDER; rect.bottom+=EDIT_BORDER; rect.right-=5;// add just now
	rect.bottom-=3;
	Draw.SetDrawFontSize(EditFontHeight,EditFontWidth,FW_NORMAL,__FONT_NORMAL__);
	if(m_nNum<=0)
		str.Format(L"%d",m_nNum);
	else str.Format(L"+%d",m_nNum);

	Draw.DrawFillRoundRect(&rect,RGB(255,255,255),5,5);
	COLORREF oldClr = Draw.SetDrawTextColor(0);
	Draw.DrawStringRect((LPTSTR)(LPCTSTR)str,&rect,DT_CENTER|DT_VCENTER);
	Draw.SetDrawTextColor(oldClr);
	
	if(hOldFont) Draw.SetFont(hOldFont);
	int b = DeleteObject(m_hFont);
	m_hFont = NULL;
   //   return 0;

} 

LRESULT CPalletenWnd::OnButton1(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
  m_nNum++;
  if(m_nNum>1000) m_nNum = 1000;

  CRect rect;
	rect.left=EDIT_X,rect.right = EDIT_X+EDIT_W;
	rect.top = EDIT_Y, rect.bottom = rect.top+EDIT_H;
   InvalidateRect(&rect);
  return 0;
}
LRESULT CPalletenWnd::OnButton2(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
  m_nNum--;
  if(m_nNum<-1000) m_nNum = -1000;
  CRect rect;
	rect.left=EDIT_X,rect.right = EDIT_X+EDIT_W;
	rect.top = EDIT_Y, rect.bottom = rect.top+EDIT_H;
   InvalidateRect(&rect);
  return 0;
}


LRESULT CPalletenWnd::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
//	SetEvent(ghExitEvent);
//	if(	g_hCommandThread ) WaitForSingleObject(g_hCommandThread,TIMEOUT_COMMAND); g_hCommandThread=0;
	__restore_pre_window_handle__(m_hWnd);
	EndDialog(0); //CPalletenWnd::DestroyWindow();
//CloseHandle(ghExitEvent);
//	Cleanup();
	//PostQuitMessage(0);
	
	return 0;
}

LRESULT CPalletenWnd::OnOK(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	__restore_pre_window_handle__(m_hWnd);
	EndDialog(IDOK); //CPalletenWnd::DestroyWindow();

	return 0;
}



	LRESULT CPalletenWnd::OnChangeSkin(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	m_DrawList->ChangeSkin();
	EnumChildWindows(m_hWnd,EnumCallback ,0);
	return 0;
}